extern AFun symClosure;

static inline ATerm makeClosure(ATermList e1, ATermList e2) {
    return (ATerm) ATmakeAppl2(symClosure, (ATerm) e1, (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchClosure(ATerm e, ATermList & e1, ATermList & e2) {
    if (ATgetType(e) != AT_APPL || ATgetAFun(e) != symClosure) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symDerive;

static inline ATerm makeDerive(ATermList e1, ATermList e2, ATerm e3, ATerm e4, ATermList e5, ATermList e6) {
    return (ATerm) ATmakeAppl6(symDerive, (ATerm) e1, (ATerm) e2, e3, e4, (ATerm) e5, (ATerm) e6);
}

#ifdef __cplusplus
static inline bool matchDerive(ATerm e, ATermList & e1, ATermList & e2, ATerm & e3, ATerm & e4, ATermList & e5, ATermList & e6) {
    if (ATgetType(e) != AT_APPL || ATgetAFun(e) != symDerive) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    e4 = ATgetArgument(e, 3);
    e5 = (ATermList) ATgetArgument(e, 4);
    e6 = (ATermList) ATgetArgument(e, 5);
    return true;
}
#endif


extern AFun symEnvBinding;

static inline ATerm makeEnvBinding(ATerm e1, ATerm e2) {
    return (ATerm) ATmakeAppl2(symEnvBinding, e1, e2);
}

#ifdef __cplusplus
static inline bool matchEnvBinding(ATerm e, ATerm & e1, ATerm & e2) {
    if (ATgetType(e) != AT_APPL || ATgetAFun(e) != symEnvBinding) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symClosureElem;

static inline ATerm makeClosureElem(ATerm e1, ATermList e2) {
    return (ATerm) ATmakeAppl2(symClosureElem, e1, (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchClosureElem(ATerm e, ATerm & e1, ATermList & e2) {
    if (ATgetType(e) != AT_APPL || ATgetAFun(e) != symClosureElem) return false;
    e1 = ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    return true;
}
#endif


void initStoreExprHelpers();

static inline const char * aterm2String(ATerm t) {
    return (const char *) ATgetName(ATgetAFun(t));
}

